LeetCode #235 - Lowest Common Ancestor of a Binary Search Tree

题目描述:

Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST.

According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes p and q as the lowest node in T that has both p and q as descendants (where we allow a node to be a descendant of itself).”

Given binary search tree:  root = [6,2,8,0,4,7,9,null,null,3,5]

        _______6______
       /              \
    ___2__          ___8__
   /      \        /      \
   0      _4       7       9
         /  \
         3   5

Example 1:

Input: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 8
Output: 6

Example 2:

Input: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 4
Output: 2
Explanation: The LCA of nodes 2 and 4 is 2, since a node can be a descendant of itself 
             according to the LCA definition.

Note:

  • All of the nodes' values will be unique.
  • p and q are different and both values will exist in the BST.

寻找BST中两个节点的最近公共祖先,由于是BST,所以可以根据根节点的值来决定网哪边的子树搜索。一旦发现根节点的值位于两个目标值之间,那么说明它就是最近的公共祖先。

class Solution {
public:
    TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) {
        int low=min(p->val,q->val);
        int high=max(p->val,q->val);
        if(root->val==low||root->val==high) return root;
        else if(root->val<high&&root->val>low) return root;
        else if(root->val>high) return lowestCommonAncestor(root->left,p,q);
        else if(root->val<low) return lowestCommonAncestor(root->right,p,q);
    }
};

猜你喜欢

转载自blog.csdn.net/LawFile/article/details/81189459